% BibTex Database
%===============================================================================

% ------------------------------------------------------------------------------
% Miscellaneous



% ------------------------------------------------------------------------------
% Books & Papers

@book{gamma:design-patterns,
	title = {Design Patterns, Elements of Resusable Object-Oriented Software},
	author = {Gamma, Erich and Helm, Richard and Johnson, Ralph and Vlissides, John},
	year = {1995},
	publisher = {Addison-Wesley}
}

@book{labrosse_2009,
	place={Weston, FL}, 
	title={uC/OS-III: the real-time Kernel}, 
	publisher={Micrium Press}, 
	author={Labrosse, Jean J.}, 
	year={2009}
} 

@book{blandy_orendorff_2017, 
	place={Sebastopol, CA}, 
	title={Programming Rust: fast, safe systems development}, 
	publisher={OReilly Media}, 
	author={Blandy, Jim and Orendorff, Jason}, 
	year={2017}
} 

@book{nichols_rust_2019,
	title = {The {Rust} {Programming} {Language} ({Covers} {Rust} 2018)},
	urldate = {2020-12-22},
	author = {Nichols, Carol and Klabnik, Steve},
	year = {2019},
	publisher={no starch press}, 
	url = {https://doc.rust-lang.org/book},
	place={San Francisco, CA}, 
}

@book{tanenbaum_bos_2015, 
	place={Englewood Cliffs, NJ}, 
	title={Modern operating systems}, 
	publisher={Prentice Hall}, 
	author={Tanenbaum, Andrew S. and Bos, Herbert}, 
	year={2015}
}

@book{yiu_beckmann_2014, 
	title={Definitive Guide to ARM® Cortex®-M3 and Cortex®-M4 Processors}, 
	publisher={Elsevier, Inc.}, 
	author={Yiu, Joseph and Beckmann, Paul}, 
	year={2014}
}

@book{buttazzo_2005, 
	place={Nueva York}, 
	title={Hard real-time computing systems: predictable scheduling algorithms and applications}, 
	publisher={Springer}, 
	author={Buttazzo, Giorgio C.}, 
	year={2005}
} 

@INPROCEEDINGS{eriksson:rtfm,
	author={J. {Eriksson} and F. {Häggström} and S. {Aittamaa} and A. {Kruglyak} and P. {Lindgren}},
	booktitle={2013 8th IEEE International Symposium on Industrial Embedded Systems (SIES)}, 
	title={Real-time for the masses, step 1: Programming API and static priority SRP kernel primitives}, 
	year={2013},
	volume={},
	number={},
	pages={110-113},
	doi={10.1109/SIES.2013.6601482}
}


% ------------------------------------------------------------------------------
% Online Sources

@misc{rust-embedded:book,
	author = "{Embedded Rust Workgroup}",
	title = "{The Embedded Rust Book}",
	year = {2020},
	publisher = {GitHub},
	url = {https://rust-embedded.github.io/book/},
	urldate = {2020-12-29},
}

@misc{rust:lang,
	author = "{Rust Team}",
	title = "{Rust Programming Language}",
	url = {https://www.rust-lang.org/},
	urldate = {2021-01-05}
}

% RTOS comparison
@misc{apache:mynewt,
	author = "{Apache}",
	title = "{Apache Mynewt}",
	url = {https://mynewt.apache.org/},
	urldate = {2020-10-23}
}
@misc{arm:mbed,
	author = "{ARM Limitted}",
	title = "{An introduction to Arm Mbed OS 6}",
	url = {https://os.mbed.com/docs/mbed-os/v6.3/introduction/index.html},
	urldate = {2020-10-23}
}
@misc{contiki-ng,
	author = "{Contiki-NG}",
	title = "{Contiki-NG: The OS for Next Generation IoT Devices}",
	url = {https://github.com/contiki-ng/contiki-ng},
	urldate = {2020-10-23},
	publisher = {GitHub},
  	journal = {GitHub repository}
}
@misc{riot-os,
	author = "{Riot}",
	title = "{The friendly Operating System for the Internet of Things.}",
	url = {https://www.riot-os.org/},
	urldate = {2020-10-23}
}
@misc{linux:zephyr,
	author = "{Zephyr Project}",
	title = "{Zephyr Project Documentation}",
	url = {https://docs.zephyrproject.org/latest/},
	urldate = {2020-10-23}
}
@misc{microsoft:azure-rtos,
	author = "{Microsoft}",
	title = "{Azure RTOS}",
	publisher = "{GitHub}",
	url = {https://github.com/azure-rtos},
	urldate = {2021-01-04}
}
@misc{segger:embos,
	author = "{SEGGER Microcontroller GmbH}",
	title = "{embOS - RTOS}",
	url = {https://www.segger.com/products/rtos/embos/},
	urldate = {2020-10-23}
}
@misc{amazon:freertos,
	author = "{Amazon Web Services}",
	title = "{The FreeRTOS™Reference Manual}",
	url = {https://www.freertos.org/fr-content-src/uploads/2018/07/FreeRTOS_Reference_Manual_V10.0.0.pdf},
	urldate = {2020-10-23}
}
@misc{mentor:nucleus,
	author = "{Mentor Graphics}",
	title = "{Nucleus RTOS}",
	url = {https://www.mentor.com/embedded-software/nucleus/},
	urldate = {2020-10-23}
}
@misc{ti:rtos,
	author = "{Texas Instruments}",
	title = "{TI-RTOS: Real-Time Operating System (RTOS) for Microcontrollers (MCU)}",
	url = {https://www.ti.com/tool/TI-RTOS-MCU},
	urldate = {2020-10-23}
}
@misc{rtic,
	author = "{RTIC}",
	title = "{Real-Time Interrupt-driven Concurrency}",
	url = {https://rtic.rs/0.5/book/en/},
	urldate = {2020-10-23}
}
@misc{tock-os,
	author = "{TockOS}",
	title = "{Tock Embedded Operating System}",
	url = {https://www.tockos.org/},
	urldate = {2020-10-23}
}
@misc{drone-os,
	author = "Valentine Valyaeff",
	title = "{Drone OS}",
	url = {https://book.drone-os.com/},
	urldate = {2020-10-23}
}

@misc{wittenstein:safertos,
	author = "{WITTENSTEIN aerospace and simulation Ltd}",
	title = "{Pre-Certified Safety RTOS}",
	url = {https://www.highintegritysystems.com/safertos/},
	urldate = {2020-10-23}
}

@misc{micrium:cert-pack,
	author = "{Silicon Labs}",
	title = "{Micrium Cert-Pack}",
	url = {https://www.micrium.com/certification/certification-kits/},
	urldate = {2020-10-23}
}

@misc{silabs:micrium-github,
	author = "{Silicon Labs}",
	title = "{Micrium Repositories}",
	publisher = {GitHub},
	url = {https://github.com/Micrium},
	urldate = {2020-10-23}
}

@misc{zephyr:functional-safety,
	author = "{Zephyr Project}",
	title = "{Zephyr Project RTOS – First Functional Safety Certification Submission for an Open Source Real Time Operating System}",
	url = {https://www.zephyrproject.org/zephyr-project-rtos-first-functional-safety-certification-submission-for-an-open-source-real-time-operating-system/},
	urldate = {2020-10-23}
}

@misc{zephyr:repo,
	author = "{Zephyr Project}",
	title = "{Primary Git Repository for the Zephyr Projec}",
	publischer = "GitHub",
	url = {https://github.com/zephyrproject-rtos/zephyr},
	urldate = {2021-01-03}
}


@misc{luethi:pyhton-visualization,
	author = "Stefan Lüthi",
	title = "{Orientation Visualization}",
	url = {https://gitlab.com/bern-rtos/demo/bare-metal-and-rtic/3d-visualization},
	urldate = {2021-02-23},
	publisher = {GitLab},
  	journal = {GitLab repository}
}
@misc{luethi:rust-demo,
	author = "Stefan Lüthi",
	title = "{Rust 3D Orientation Demo}",
	url = {https://gitlab.com/bern-rtos/demo/bare-metal-and-rtic/rust-3d-orientation-demo},
	urldate = {2021-02-23},
	publisher = {GitLab},
  	journal = {GitLab repository}
}

% ------------------------------------------------------------------------------
% Images





% ------------------------------------------------------------------------------
% Datasheets
